Data Structures | Functions | Variables

# strings_func.h File Reference

Functions related to OTTD's strings. More...

`#include "strings_type.h"`
`#include "string_type.h"`
`#include "gfx_type.h"`

Go to the source code of this file.

## Data Structures
class | StringParameters
class | MissingGlyphSearcher
| A searcher for missing glyphs. More...
## Functions
char * | InlineString (char *buf, StringID string)
char * | GetString (char *buffr, StringID string, const char *last)
char * | GetStringWithArgs (char *buffr, StringID string, StringParameters *args, const char *last, uint case_index=0, bool game_script=false)
| Get a parsed string with most special stringcodes replaced by the string parameters.
const char * | GetStringPtr (StringID string)
uint | ConvertKmhishSpeedToDisplaySpeed (uint speed)
| Convert the given km/h-ish speed to the display speed.
uint | ConvertDisplaySpeedToKmhishSpeed (uint speed)
| Convert the given display speed to the km/h-ish speed.
void | InjectDParam (uint amount)
| Shift the string parameters in the global string parameter array by amount positions, making room at the beginning.
static void | SetDParamX (uint64 *s, uint n, uint64 v)
| Set a string parameter v at index n in a given array s.
static void | SetDParam (uint n, uint64 v)
| Set a string parameter v at index n in the global string parameter array.
void | SetDParamMaxValue (uint n, uint64 max_value, uint min_count=0)
| Set DParam n to some number that is suitable for string size computations.
void | SetDParamMaxDigits (uint n, uint count)
| Set DParam n to some number that is suitable for string size computations.
void | SetDParamStr (uint n, const char *str)
| This function is used to "bind" a C string to a OpenTTD dparam slot.
void | CopyInDParam (int offs, const uint64 *src, int num)
| Copy num string parameters from array src into the global string parameter array.
void | CopyOutDParam (uint64 *dst, int offs, int num)
| Copy num string parameters from the global string parameter array to the dst array.
void | CopyOutDParam (uint64 *dst, const char **strings, StringID string, int num)
| Copy num string parameters from the global string parameter array to the dst array.
static uint64 | GetDParamX (const uint64 *s, uint n)
| Get the current string parameter at index n from parameter array s.
static uint64 | GetDParam (uint n)
| Get the current string parameter at index n from the global string parameter array.
void | InitializeLanguagePacks ()
| Make a list of the available language packs.
const char * | GetCurrentLanguageIsoCode ()
| Get the ISO language code of the currently loaded language.
int CDECL | StringIDSorter (const StringID *a, const StringID *b)
void | CheckForMissingGlyphs (bool base_font=true, MissingGlyphSearcher *search=NULL)
| Check whether the currently loaded language pack uses characters that the currently loaded font does not support.
## Variables
StringParameters | _global_string_params
TextDirection | _current_text_dir
| Text direction of the currently selected language.

## Detailed Description

Functions related to OTTD's strings.

Definition in file strings_func.h.

## Function Documentation

void CheckForMissingGlyphs | ( | bool | base_font,
|  | MissingGlyphSearcher * | searcher |
| ) |  |  |

Check whether the currently loaded language pack uses characters that the currently loaded font does not support.

If this is the case an error message will be shown in English. The error message will not be localized because that would mean it might use characters that are not in the font, which is the whole reason this check has been added.

Parameters:

  | base_font | Whether to look at the base font as well.
  | searcher | The methods to use to search for strings to check. If NULL the loaded language pack searcher is used.

Definition at line 2115 of file strings.cpp.

References _current_text_dir, MissingGlyphSearcher::FindMissingGlyphs(), InitFreeType(), INVALID_STRING_ID, LanguagePackHeader::isocode, LoadStringWidthTable(), MissingGlyphSearcher::Monospace(), SetDParamStr(), SetFallbackFont(), ShowErrorMessage(), TD_LTR, Utf8Encode(), LanguagePackHeader::winlangid, WL_ERROR, and WL_WARNING.

Referenced by HandleBootstrap(), LoadIntroGame(), TextfileWindow::LoadTextfile(), and GameOptionsWindow::OnDropdownSelect().

uint ConvertDisplaySpeedToKmhishSpeed | ( | uint | speed | ) |

Convert the given display speed to the km/h-ish speed.

Parameters:

  | speed | the speed to convert

Returns:
  the converted speed.

Definition at line 756 of file strings.cpp.

References _settings_game, Units::c_velocity, UnitConversion::FromDisplay(), GameSettings::locale, and LocaleSettings::units.

Referenced by TimetableWindow::OnQueryTextFinished().

uint ConvertKmhishSpeedToDisplaySpeed | ( | uint | speed | ) |

Convert the given km/h-ish speed to the display speed.

Parameters:

  | speed | the speed to convert

Returns:
  the converted speed.

Definition at line 746 of file strings.cpp.

References _settings_game, Units::c_velocity, GameSettings::locale, UnitConversion::ToDisplay(), and LocaleSettings::units.

Referenced by FormatString(), and TimetableWindow::OnClick().

void CopyInDParam | ( | int | offs,
|  | const uint64 * | src,
|  | int | num |
| ) |  |  |

Copy num string parameters from array src into the global string parameter array.

Parameters:

  | offs | Index in the global array to copy the first string parameter to.
  | src | Source array of string parameters.
  | num | Number of string parameters to copy.

Definition at line 131 of file strings.cpp.

References StringParameters::GetPointerToOffset(), and MemCpyT().

Referenced by DrawNewsString(), NewsWindow::DrawWidget(), QueryWindow::SetStringParameters(), and NewsWindow::UpdateWidgetSize().

void CopyOutDParam | ( | uint64 * | dst,
|  | int | offs,
|  | int | num |
| ) |  |  |

Copy num string parameters from the global string parameter array to the dst array.

Parameters:

  | dst | Destination array of string parameters.
  | offs | Index in the global array to copy the first string parameter from.
  | num | Number of string parameters to copy.

Definition at line 142 of file strings.cpp.

References StringParameters::GetPointerToOffset(), and MemCpyT().

Referenced by AddNewsItem(), and ErrorMessageData::CopyOutDParams().

void CopyOutDParam | ( | uint64 * | dst,
|  | const char ** | strings,
|  | StringID | string,
|  | int | num |
| ) |  |  |

Copy num string parameters from the global string parameter array to the dst array.

Furthermore clone raw string parameters into strings and amend the data in dst.

Parameters:

  | dst | Destination array of string parameters.
  | strings | Destination array for clone of the raw strings. Must be of same length as dst. Deallocation left to the caller.
  | string | The string used to determine where raw strings are and where there are no raw strings.
  | num | Number of string parameters to copy.

Definition at line 155 of file strings.cpp.

References DRAW_STRING_BUFFER, StringParameters::GetPointerToOffset(), StringParameters::GetTypeAtOffset(), StringParameters::HasTypeInformation(), lastof, and MemCpyT().

const char* GetCurrentLanguageIsoCode | ( |  | ) |

Get the ISO language code of the currently loaded language.

Returns:
  the ISO code.

Definition at line 2011 of file strings.cpp.

References LanguagePackHeader::isocode.

Referenced by GameOptionsWindow::DrawWidget(), GetTextfile(), and GameOptionsWindow::UpdateWidgetSize().

static uint64 GetDParam | ( | uint | n | ) | `[inline, static]`

Get the current string parameter at index n from the global string parameter array.

Parameters:

  | n | Index of the string parameter.

Returns:
  Value of the requested string parameter.

Definition at line 183 of file strings_func.h.

static uint64 GetDParamX | ( | const uint64 * | s,
|  | uint | n |
| ) |  |  | `[inline, static]`

Get the current string parameter at index n from parameter array s.

Parameters:

  | s | Array of string parameters.
  | n | Index of the string parameter.

Returns:
  Value of the requested string parameter.

Definition at line 173 of file strings_func.h.

Referenced by ErrorMessageData::CopyOutDParams().

char* GetStringWithArgs | ( | char * | buffr,
|  | StringID | string,
|  | StringParameters * | args,
|  | const char * | last,
|  | uint | case_index,
|  | bool | game_script |
| ) |  |  |

Get a parsed string with most special stringcodes replaced by the string parameters.

Parameters:

  | buffr | Pointer to a string buffer where the formatted string should be written to.
  | string |
  | args | Arguments for the string.
  | last | Pointer just past the end of buffr.
  | case_index | The "case index". This will only be set when FormatString wants to print the string in a different case.
  | game_script | The string is coming directly from a game script.

Returns:
  Pointer to the final zero byte of the formatted string.

Definition at line 211 of file strings.cpp.

References _langtab_num, error(), FormatString(), GAME_TEXT_TAB, GB(), GetGameStringPtr(), GetGRFStringID(), GetGRFStringPtr(), StringParameters::GetInt32(), GetStringWithArgs(), HasBit(), TAB_COUNT_BITS, TAB_COUNT_OFFSET, TAB_SIZE_BITS, and TAB_SIZE_OFFSET.

Referenced by FormatString(), GetStringWithArgs(), and GetTownName().

void InitializeLanguagePacks | ( |  | ) |

Make a list of the available language packs.

Put the data in _languages list.

< Matching the language in the configuration file or the current locale

< Using pt_PT for pt_BR locale when pt_BR is not available

< Fallback when no locale-matching language has been found

Definition at line 1963 of file strings.cpp.

References _config_language_file, SmallVector< T, S >::Begin(), SmallVector< T, S >::End(), LanguageMetadata::file, FOR_ALL_SEARCHPATHS, GetCurrentLocale(), GetLanguageList(), LANG_DIR, SmallVector< T, S >::Length(), lengthof, ReadLanguagePack(), and usererror().

void InjectDParam | ( | uint | amount | ) |

Shift the string parameters in the global string parameter array by amount positions, making room at the beginning.

Parameters:

  | amount | Number of positions to shift.

Definition at line 299 of file strings.cpp.

References StringParameters::ShiftParameters().

Referenced by Subsidy::AwardTo().

static void SetDParam | ( | uint | n,
|  | uint64 | v |
| ) |  |  | `[inline, static]`

Set a string parameter v at index n in the global string parameter array.

Parameters:

  | n | Index of the string parameter.
  | v | Value of the string parameter.

Definition at line 153 of file strings_func.h.

Referenced by AdvertiseIndustryOpening(), AgeVehicle(), AircraftEntersTerminal(), AircraftHandleDestTooFar(), Subsidy::AwardTo(), CcBuildIndustry(), ChangeIndustryProduction(), NetworkChatWindow::ChatTabCompletionNextItem(), CheckAllowRemoveRoad(), CheckCompanyHasMoney(), ClientNetworkGameSocketHandler::CheckConnection(), CheckforTownRating(), CheckIfAuthorityAllowsNewStation(), CheckOrders(), CheckTrainCollision(), CheckTrainsLengths(), ClearTile_Station(), CmdBuildAirport(), CmdBuildBridge(), CmdCompanyCtrl(), CmdDecreaseLoan(), CmdFoundTown(), CmdIncreaseLoan(), CompanyCheckBankrupt(), CrashAirplane(), Disaster_CoalMine_Init(), DisasterTick_Aircraft(), DisasterTick_Big_Ufo(), DisasterTick_Zeppeliner(), DoCommandPInternal(), CargoesField::Draw(), StationViewWindow::DrawAcceptedCargo(), DrawAircraftDetails(), StationViewWindow::DrawCargoRatings(), NetworkContentListWindow::DrawDetails(), DrawEngineList(), StationViewWindow::DrawEntries(), SelectCompanyManagerFaceWindow::DrawFaceStringLabel(), BaseGraphWindow::DrawGraph(), VehicleGroupWindow::DrawGroupInfo(), IndustryViewWindow::DrawInfo(), DrawOrderString(), DrawPrice(), TownAuthorityWindow::DrawRatings(), DrawRoadVehDetails(), NetworkGameWindow::DrawServerLine(), SettingEntry::DrawSetting(), DrawShipDetails(), DrawStationCoverageAreaText(), SmallMapWindow::DrawTowns(), DrawTrainDetails(), DepotWindow::DrawVehicleInDepot(), BaseVehicleListWindow::DrawVehicleListItems(), DrawVehiclePurchaseInfo(), DrawVehicleRefitWindow(), VehicleViewWindow::DrawWidget(), VehicleDetailsWindow::DrawWidget(), TownDirectoryWindow::DrawWidget(), TownViewWindow::DrawWidget(), TownAuthorityWindow::DrawWidget(), ScenarioEditorToolbarWindow::DrawWidget(), TimetableWindow::DrawWidget(), SubsidyListWindow::DrawWidget(), StatusBarWindow::DrawWidget(), SelectStationWindow< T >::DrawWidget(), CompanyStationsWindow::DrawWidget(), SmallMapWindow::DrawWidget(), GameSettingsWindow::DrawWidget(), BuildRailStationWindow::DrawWidget(), BuildObjectWindow::DrawWidget(), MessageHistoryWindow::DrawWidget(), ScanProgressWindow::DrawWidget(), NewGRFParametersWindow::DrawWidget(), SpriteAlignerWindow::DrawWidget(), NetworkJoinStatusWindow::DrawWidget(), MusicWindow::DrawWidget(), MusicTrackSelectionWindow::DrawWidget(), TooltipsWindow::DrawWidget(), SelectGameWindow::DrawWidget(), BuildIndustryWindow::DrawWidget(), PerformanceRatingDetailWindow::DrawWidget(), CompanyLeagueWindow::DrawWidget(), PaymentRatesGraphWindow::DrawWidget(), GraphLegendWindow::DrawWidget(), GenerateProgressWindow::DrawWidget(), SaveLoadWindow::DrawWidget(), EnginePreviewWindow::DrawWidget(), BuyCompanyWindow::DrawWidget(), CompanyWindow::DrawWidget(), CompanyInfrastructureWindow::DrawWidget(), CompanyFinancesWindow::DrawWidget(), CheatWindow::DrawWidget(), BuildBridgeWindow::DrawWidget(), ReplaceVehicleWindow::DrawWidget(), BuildAirportWindow::DrawWidget(), AISettingsWindow::DrawWidget(), AIListWindow::DrawWidget(), DrawYearColumn(), EngineNameSorter(), ErrorUnknownCallbackResult(), FloodVehicle(), GenerateCompanyName(), GenerateDefaultSaveName(), GeneratePresidentName(), RefitWindow::GetCapacityString(), StationViewWindow::GetEntryString(), IndustryDirectoryWindow::GetIndustryString(), GetNameOfOwner(), GetSaveLoadErrorString(), BaseGraphWindow::GetYLabelWidth(), GRFLoadConfig(), VehicleGroupWindow::GroupNameSorter(), Vehicle::HandlePathfindingResult(), IndustryDirectoryWindow::IndustryNameSorter(), IndustryProductionCallback(), IndustryTypeNameSorter(), MenuClickLargeWorldScreenshot(), NetworkHandlePauseChange(), NetworkServerSendChat(), NewVehicleAvailable(), WaypointWindow::OnClick(), VehicleDetailsWindow::OnClick(), TownViewWindow::OnClick(), TimetableWindow::OnClick(), StationViewWindow::OnClick(), CustomCurrencyWindow::OnClick(), GameSettingsWindow::OnClick(), OrdersWindow::OnClick(), NewGRFParametersWindow::OnClick(), NetworkStartServerWindow::OnClick(), IndustryViewWindow::OnClick(), CreateScenarioWindow::OnClick(), GenerateLandscapeWindow::OnClick(), DepotWindow::OnClick(), SetDateWindow::OnClick(), CompanyWindow::OnClick(), SelectCompanyManagerFaceWindow::OnClick(), CheatWindow::OnClick(), BuildVehicleWindow::OnClick(), AISettingsWindow::OnClick(), GenerateLandscapeWindow::OnDropdownSelect(), SmallMapWindow::OnInit(), LandInfoWindow::OnInit(), SelectCompanyManagerFaceWindow::OnInit(), HighScoreWindow::OnPaint(), EndGameWindow::OnPaint(), BuildAirportWindow::OnPaint(), BuildIndustryWindow::OnPlaceObject(), DepotWindow::OnRightClick(), ServerNetworkUDPSocketHandler::Receive_CLIENT_DETAIL_INFO(), ClientNetworkGameSocketHandler::Receive_SERVER_CHAT(), ReportNewsProductionChangeIndustry(), RoadVehArrivesAt(), SaveHighScoreValue(), SaveHighScoreValueNetwork(), ServerNetworkAdminSocketHandler::SendCompanyInfo(), ServerNetworkAdminSocketHandler::SendCompanyUpdate(), SetArrivalDepartParams(), SetDParamMaxDigits(), SetDParamStr(), NIHelper::SetObjectAtStringParameters(), NIHelper::SetSimpleStringParameters(), WaypointWindow::SetStringParameters(), ExtraViewportWindow::SetStringParameters(), VehicleViewWindow::SetStringParameters(), VehicleDetailsWindow::SetStringParameters(), VehicleListWindow::SetStringParameters(), RefitWindow::SetStringParameters(), TownDirectoryWindow::SetStringParameters(), TownViewWindow::SetStringParameters(), TownAuthorityWindow::SetStringParameters(), TimetableWindow::SetStringParameters(), StationViewWindow::SetStringParameters(), CompanyStationsWindow::SetStringParameters(), SmallMapWindow::SetStringParameters(), CustomCurrencyWindow::SetStringParameters(), GameSettingsWindow::SetStringParameters(), GameOptionsWindow::SetStringParameters(), BuildSignalWindow::SetStringParameters(), BuildRailStationWindow::SetStringParameters(), BuildRailToolbarWindow::SetStringParameters(), OskWindow::SetStringParameters(), OrdersWindow::SetStringParameters(), BuildObjectWindow::SetStringParameters(), NewsWindow::SetStringParameters(), NewGRFParametersWindow::SetStringParameters(), SpriteAlignerWindow::SetStringParameters(), NetworkStartServerWindow::SetStringParameters(), NetworkGameWindow::SetStringParameters(), MusicTrackSelectionWindow::SetStringParameters(), QueryWindow::SetStringParameters(), QueryStringWindow::SetStringParameters(), IndustryCargoesWindow::SetStringParameters(), IndustryDirectoryWindow::SetStringParameters(), IndustryViewWindow::SetStringParameters(), BuildIndustryWindow::SetStringParameters(), VehicleGroupWindow::SetStringParameters(), GoalQuestionWindow::SetStringParameters(), CreateScenarioWindow::SetStringParameters(), GenerateLandscapeWindow::SetStringParameters(), DepotWindow::SetStringParameters(), BuyCompanyWindow::SetStringParameters(), CompanyWindow::SetStringParameters(), CompanyInfrastructureWindow::SetStringParameters(), SelectCompanyLiveryWindow::SetStringParameters(), CompanyFinancesWindow::SetStringParameters(), BuildVehicleWindow::SetStringParameters(), ReplaceVehicleWindow::SetStringParameters(), BuildAirportWindow::SetStringParameters(), AIDebugWindow::SetStringParameters(), AIConfigWindow::SetStringParameters(), AISettingsWindow::SetStringParameters(), AIListWindow::SetStringParameters(), SetTimetableParams(), SetupSubsidyDecodeParam(), SettingEntry::SetValueDParams(), ShipArrivesAt(), ShowCostOrIncomeAnimation(), ShowEstimatedCostOrIncome(), ShowFeederIncomeAnimation(), ShowFillingPercent(), ShowNewGRFError(), ShowNewGrfVehicleError(), ShowRefitOptionsList(), ShowRejectOrAcceptNews(), SignList::SignNameFilter(), SignList::SignNameSorter(), CompanyStationsWindow::StationNameSorter(), ToolbarScenDatePanel(), TownDirectoryWindow::TownNameSorter(), TrainDetailsCapacityTab(), TrainDetailsCargoTab(), TrainDetailsInfoTab(), TrainEnterStation(), UpdateFillingPercent(), SettingEntry::UpdateFilterState(), Waypoint::UpdateVirtCoord(), Town::UpdateVirtCoord(), Station::UpdateVirtCoord(), Sign::UpdateVirtCoord(), VehicleDetailsWindow::UpdateWidgetSize(), TownDirectoryWindow::UpdateWidgetSize(), TownAuthorityWindow::UpdateWidgetSize(), ScenarioEditorToolbarWindow::UpdateWidgetSize(), StatusBarWindow::UpdateWidgetSize(), SelectStationWindow< T >::UpdateWidgetSize(), CustomCurrencyWindow::UpdateWidgetSize(), GameSettingsWindow::UpdateWidgetSize(), GameOptionsWindow::UpdateWidgetSize(), BuildRailStationWindow::UpdateWidgetSize(), MessageHistoryWindow::UpdateWidgetSize(), MusicTrackSelectionWindow::UpdateWidgetSize(), TooltipsWindow::UpdateWidgetSize(), SelectGameWindow::UpdateWidgetSize(), BuildIndustryWindow::UpdateWidgetSize(), PerformanceRatingDetailWindow::UpdateWidgetSize(), CompanyLeagueWindow::UpdateWidgetSize(), PaymentRatesGraphWindow::UpdateWidgetSize(), BaseGraphWindow::UpdateWidgetSize(), CreateScenarioWindow::UpdateWidgetSize(), GenerateLandscapeWindow::UpdateWidgetSize(), EnginePreviewWindow::UpdateWidgetSize(), DepotWindow::UpdateWidgetSize(), BuyCompanyWindow::UpdateWidgetSize(), CompanyWindow::UpdateWidgetSize(), CompanyInfrastructureWindow::UpdateWidgetSize(), CheatWindow::UpdateWidgetSize(), BuildBridgeWindow::UpdateWidgetSize(), ReplaceVehicleWindow::UpdateWidgetSize(), BuildAirportWindow::UpdateWidgetSize(), VehicleEnterDepot(), and VehicleNameSorter().

void SetDParamMaxDigits | ( | uint | n,
|  | uint | count |
| ) |  |  |

Set DParam n to some number that is suitable for string size computations.

Parameters:

  | n | Index of the string parameter.
  | count | Number of digits which shall be displayable.

< Digit with the biggest string width.

Definition at line 115 of file strings.cpp.

References SetDParam().

Referenced by DrawEngineList(), SetDParamMaxValue(), TownDirectoryWindow::UpdateWidgetSize(), ScanProgressWindow::UpdateWidgetSize(), and NetworkJoinStatusWindow::UpdateWidgetSize().

void SetDParamMaxValue | ( | uint | n,
|  | uint64 | max_value,
|  | uint | min_count |
| ) |  |  |

Set DParam n to some number that is suitable for string size computations.

Parameters:

  | n | Index of the string parameter.
  | max_value | The biggest value which shall be displayed. For the result only the number of digits of max_value matter.
  | min_count | Minimum number of digits independent of max.

Definition at line 100 of file strings.cpp.

References max(), and SetDParamMaxDigits().

Referenced by VehicleGroupWindow::ComputeGroupInfoSize(), TimetableWindow::DrawWidget(), OrdersWindow::DrawWidget(), VehicleDetailsWindow::UpdateWidgetSize(), TimetableWindow::UpdateWidgetSize(), StatusBarWindow::UpdateWidgetSize(), ScanProgressWindow::UpdateWidgetSize(), NewGRFParametersWindow::UpdateWidgetSize(), NetworkJoinStatusWindow::UpdateWidgetSize(), NetworkGameWindow::UpdateWidgetSize(), PerformanceRatingDetailWindow::UpdateWidgetSize(), BaseGraphWindow::UpdateWidgetSize(), GenerateProgressWindow::UpdateWidgetSize(), CreateScenarioWindow::UpdateWidgetSize(), GenerateLandscapeWindow::UpdateWidgetSize(), DepotWindow::UpdateWidgetSize(), CompanyWindow::UpdateWidgetSize(), CompanyInfrastructureWindow::UpdateWidgetSize(), CompanyFinancesWindow::UpdateWidgetSize(), and CheatWindow::UpdateWidgetSize().

void SetDParamStr | ( | uint | n,
|  | const char * | str |
| ) |  |  |

This function is used to "bind" a C string to a OpenTTD dparam slot.

Parameters:

  | n | slot of the string
  | str | string to bind

Definition at line 290 of file strings.cpp.

References SetDParam().

Referenced by Subsidy::AwardTo(), CheckForMissingGlyphs(), CmdCompanyCtrl(), CmdCustomNewsItem(), CmdFoundTown(), CompanyCheckBankrupt(), NetworkContentListWindow::DrawDetails(), IndustryViewWindow::DrawInfo(), GoalListWindow::DrawPartialGoalList(), TownViewWindow::DrawWidget(), GameOptionsWindow::DrawWidget(), NewsWindow::DrawWidget(), NewGRFParametersWindow::DrawWidget(), NetworkChatWindow::DrawWidget(), MusicWindow::DrawWidget(), MusicTrackSelectionWindow::DrawWidget(), LandInfoWindow::DrawWidget(), BuildIndustryWindow::DrawWidget(), GoalQuestionWindow::DrawWidget(), SaveLoadWindow::DrawWidget(), AIConfigWindow::DrawWidget(), AISettingsWindow::DrawWidget(), AIListWindow::DrawWidget(), ErrorUnknownCallbackResult(), GenerateCompanyName(), TownViewWindow::GetDesiredInfoHeight(), IndustryDirectoryWindow::GetIndustryString(), GetSavegameFormat(), GetSaveLoadErrorString(), GRFLoadConfig(), IndustryProductionCallback(), MakeScreenshot(), CustomCurrencyWindow::OnClick(), NetworkStartServerWindow::OnClick(), NetworkGameWindow::OnClick(), LandInfoWindow::OnInit(), IConsoleWindow::OnPaint(), SaveFileError(), CustomCurrencyWindow::SetStringParameters(), GameOptionsWindow::SetStringParameters(), SpriteAlignerWindow::SetStringParameters(), NetworkLobbyWindow::SetStringParameters(), AboutWindow::SetStringParameters(), AIDebugWindow::SetStringParameters(), ShowNewGRFError(), ShowNewGrfVehicleError(), GameOptionsWindow::UpdateWidgetSize(), NetworkChatWindow::UpdateWidgetSize(), MusicWindow::UpdateWidgetSize(), MusicTrackSelectionWindow::UpdateWidgetSize(), LandInfoWindow::UpdateWidgetSize(), BuildIndustryWindow::UpdateWidgetSize(), GoalQuestionWindow::UpdateWidgetSize(), and WarnCorruptSprite().

static void SetDParamX | ( | uint64 * | s,
|  | uint | n,
|  | uint64 | v |
| ) |  |  | `[inline, static]`

Set a string parameter v at index n in a given array s.

Parameters:

  | s | Array of string parameters.
  | n | Index of the string parameter.
  | v | Value of the string parameter.

Definition at line 143 of file strings_func.h.